#![no_std]
#![feature(allocator_api)]

/// Boot services, handled by the Limine boot protocol.
pub mod boot;
/// Memory regions, allocation, flags, and whatnot.
pub mod memory;
/// Panic handling function logic.
pub mod panic;
/// Kernel command line parameter structure and enums.
pub mod params;
/// Process representation.
pub mod process;
/// Resources accessible from many parts of the code.
pub mod resources;

/// Architecture dependent.
pub mod arch;
